# 20may23 Software Lab. Alexander Burger

,"Scrawl"  "@lib/canvas.l"

`(needs "20230428")

(symbols 'pico~scrawl 'android 'pico)

(local) (*DX *DY *Mode *Path chgPath drawCanvas cnvs)

(setq *DX 400  *DY 600)

(de chgPath (Str Lst)
   (change Str
      (env 'L Lst)
      (++ *Path)
      (setq *Path L) ) )

(de drawCanvas (This Dly F X Y X2 Y2)
   (make
      (csClearRect 0 0 *DX *DY)
      (cond
         ((gt0 F)  # Click
            (if (=1 F)
               (chgPath ,"Dots" (cons (cons X Y) *Path))
               (act> (: home undo)) )
            (csPost) )
         (*Mode
            (cond
               ((=0 F)  # Start drag
                  (csDef "cnvs")
                  (case *Mode
                     ("Line"
                        (chgPath ,"Line" (cons (list X2 Y2 X Y) *Path)) )
                     ("Rect"
                        (chgPath ,"Rectangle"
                           (cons
                              (list X2 Y2 X Y2 X Y X2 Y X2 Y2)
                              *Path ) ) ) )
                  (csPost) )
               ((lt0 F)  # Drag
                  (when (pair (cdar *Path))
                     (csDraw "cnvs" 0 0)
                     (case *Mode
                        ("Line"
                           (set (car *Path) X2  (cdar *Path) Y2) )
                        ("Rect"
                           (let L (car *Path)
                              (set
                                 L X2
                                 (cdr L) Y2
                                 (cdddr L) Y2
                                 (nth L 7) X2
                                 (nth L 9) X2
                                 (nth L 10) Y2 ) ) ) )
                     (csPost) ) ) ) )
         (T
            (cond
               ((=0 F)  # Start drag
                  (chgPath ,"Stroke" (cons (list X2 Y2 X Y) *Path))
                  (csPost) )
               ((lt0 F)  # Drag
                  (if (pair (cdar *Path))
                     (push *Path Y2 X2)
                     (push '*Path (list X2 Y2 X Y)) )
                  (csPost) ) ) ) )
      (for P *Path
         (if (atom (cdr P))
            (csFillRect (car P) (cdr P) 3 3)
            (csBeginPath)
            (csMoveTo (++ P) (++ P))
            (while P
               (csLineTo (++ P) (++ P)) )
            (csStroke) ) ) ) )

(start
   (setq pico~drawCanvas drawCanvas) )

(overview T)
(menu ,"Scrawl"
   (form "center"
      (<drawCanvas> 'cnvs *DX *DY -1)
      (--)
      ,"Dots" (gui '(+Var +Radio) '*Mode)
      (<nbsp> 3)
      ,"Line" (gui '(+Radio) -1 "Line")
      (<nbsp> 3)
      ,"Rectangle" (gui '(+Radio) -2 "Rect")
      (----)
      (gui '(+Able +Button) '*Path ,"Clear"
         '(setq *Path
            (=: home undo todo (=: home redo todo NIL)) ) )
      (gui '(+UndoButton))
      (gui '(+RedoButton)) ) )
